#!/bin/sh
# $Id: ng_grep_rules.sh,v 1.4 2014/04/11 01:10:07 andy Exp $
#----------------------------------------------------------------

add_ng_node(){
	kldload ${proj}/src/ng_grep.ko
	ngctl mkpeer ipfw: grep 80 in
	ngctl name ipfw:80 grep 
	ngctl connect ipfw: grep: 81 miss
#	ngctl connect ipfw: grep: 82 meet
}

rem_ng_node(){
	ngctl shutdown grep: 
	kldunload ng_grep
}


if [ `id -u` != 0 ];then
	echo "Sorry, you must be a root to do it"
	exit 1
fi

i_am=`realpath ${0}`
my_dir=`dirname ${i_am}`
proj=`dirname ${my_dir}`

case "$1" in
start)
	add_ng_node
	${proj}/ipfw/ng_grep_rules.sh start
	;;
stop)
	${proj}/ipfw/ng_grep_rules.sh stop
	rem_ng_node
	;;
restart)
	rem_ng_node
	add_ng_node
	;;
*)
        echo "Usage: ${i_am} {start|stop|restart}" 
        ;;
esac

exit 0

