/*
 * $Id: my_pattern.h,v 1.12 2014/04/30 11:01:05 andy Exp $
 */


#ifndef _MY_PATTERN_H_
#define _MY_PATTERN_H_

/* patterns chain related staff ==============================*/
struct pattern {
	struct	pattern	* next;
	u_long	meet_c;
	u_char	flag_i_c;
	u_char	flag_rex;
	u_char	flag_url;
	u_char	flag_sub;
	u_int	length;
	u_char	* text;
	void	* precomp;
};

typedef struct pattern *pat_p;

struct precomp_url {
	u_char	* host;
	u_char	* path;
	u_int	host_l;
	u_int	path_l;
};
typedef struct precomp_url *p_url_p;

struct token {
	u_char	* text;
	u_int	leng;
};

#define P_FLAG_I_C		1
#define P_FLAG_REX		2
#define P_FLAG_URL		4
#define P_FLAG_SUB		8

#define MY_PATTERN_CMD_ADD	1
#define MY_PATTERN_CMD_DEL	2
#define MY_PATTERN_CMD_CHECK	3
#define MY_PATTERN_CMD_FLUSH	10
#define MY_PATTERN_CMD_FREE	11

#define MY_P_MAX_TOKENS		16

extern int pattern_add(pat_p, u_char*, void**, u_char);
extern int pattern_del(pat_p, u_char* , void**, u_char);
extern int pattern_check(pat_p, u_char*, void**, u_char);
extern pat_p patterns_chain_init(void);
extern int patterns_chain_flush(pat_p);
extern int patterns_chain_free(pat_p);
extern int check_incom_string(pat_p, char*, u_int);

/* end of patterns chain related staff =======================*/

#endif /* _MY_PATTERN_H_ */
