/*
 * $Id: ng_grep.h,v 1.18 2014/04/30 11:01:05 andy Exp $
 *
 * on the base if ng_echo.h from FreeBSD 10.0
 */


#ifndef _NETGRAPH_NG_GREP_H_
#define _NETGRAPH_NG_GREP_H_

/* Node type name and magic cookie */

#define NG_GREP_NODE_TYPE	"grep"
#define NG_GREP_COOKIE		250206800 // 2:5020/68.00 ;-)

#ifdef NG_SEPARATE_MALLOC
static MALLOC_DEFINE(M_NETGRAPH_GREP, "netgraph_grep", "netgraph grep node");
#else
#define M_NETGRAPH_GREP 	M_NETGRAPH
#endif

#define	NG_GREP_MAX_STR_PAR_LEN	256
/* hooks definition */

#define	NG_GREP_HOOK_IN		"in"
#define	NG_GREP_HOOK_MEET	"meet"
#define	NG_GREP_HOOK_MISS	"miss"

/* messages related staff */
/* comands */

enum {
	NGM_GREP_GETSTATS = 1,
	NGM_GREP_CLEARSTATS,
	NGM_GREP_GETCLEARSTATS,
	NGM_GREP_ADD,
	NGM_GREP_DEL,
	NGM_GREP_CHECK,
	NGM_GREP_FLUSH,
};

/* data structures for getstats comand */

struct ng_grep_stats_out {
	u_long	in_c;
	u_long	bad_c;
	u_long	meet_c;
	u_long	miss_c;
};

#define NG_GREP_STATS_OUT_TYPE_INFO {				\
	{ "income",	&ng_parse_uint64_type		},	\
	{ "bad",	&ng_parse_uint64_type		},	\
	{ "meet",	&ng_parse_uint64_type		},	\
	{ "miss",	&ng_parse_uint64_type		},	\
	{ NULL }						\
}

/* data structures for add comand */

struct ng_grep_add_in {
	u_char	flag_i_c;
	u_char	flag_rex;
	u_char	flag_sub;
	u_char	 raw[NG_GREP_MAX_STR_PAR_LEN];
	u_char	 url[NG_GREP_MAX_STR_PAR_LEN];
};

struct ng_grep_add_out {
	u_char	rc;
	u_char	flag_i_c;
	u_char	flag_rex;
	u_char	flag_sub;
	u_long	meet_c;
	u_char	raw[NG_GREP_MAX_STR_PAR_LEN];
	u_char	url[NG_GREP_MAX_STR_PAR_LEN];
	u_char	host[NG_GREP_MAX_STR_PAR_LEN];
	u_char	path[NG_GREP_MAX_STR_PAR_LEN];
	u_char	prot[8];
};

#define NG_GREP_ADD_IN_TYPE_INFO {				\
	{ "i_c",	&ng_parse_uint8_type		},	\
	{ "rex",	&ng_parse_uint8_type		},	\
	{ "sub",	&ng_parse_uint8_type		},	\
	{ "raw",	&ng_grep_add_raw_type		},	\
	{ "url",	&ng_grep_add_url_type		},	\
	{ NULL }						\
}

#define NG_GREP_ADD_OUT_TYPE_INFO {				\
	{ "err",	&ng_parse_uint8_type		},	\
	{ "i_c",	&ng_parse_uint8_type		},	\
	{ "rex",	&ng_parse_uint8_type		},	\
	{ "sub",	&ng_parse_uint8_type		},	\
	{ "meet",	&ng_parse_uint64_type		},	\
	{ "raw",	&ng_grep_add_raw_type		},	\
	{ "url",	&ng_grep_add_raw_type		},	\
	{ "host",	&ng_grep_add_host_type		},	\
	{ "path",	&ng_grep_add_path_type		},	\
	{ "prot",	&ng_grep_add_prot_type		},	\
	{ NULL }						\
}

static const struct ng_parse_fixedstring_info ng_grep_add_raw_type_info = {
	NG_GREP_MAX_STR_PAR_LEN
};
static const struct ng_parse_fixedstring_info ng_grep_add_url_type_info = {
	NG_GREP_MAX_STR_PAR_LEN
};
static const struct ng_parse_fixedstring_info ng_grep_add_host_type_info = {
	NG_GREP_MAX_STR_PAR_LEN
};
static const struct ng_parse_fixedstring_info ng_grep_add_path_type_info = {
	NG_GREP_MAX_STR_PAR_LEN
};
static const struct ng_parse_fixedstring_info ng_grep_add_prot_type_info = {
	8	
};

static const struct ng_parse_type ng_grep_add_raw_type = {
	&ng_parse_fixedstring_type,
	&ng_grep_add_raw_type_info,
};
static const struct ng_parse_type ng_grep_add_url_type = {
	&ng_parse_fixedstring_type,
	&ng_grep_add_url_type_info,
};
static const struct ng_parse_type ng_grep_add_host_type = {
	&ng_parse_fixedstring_type,
	&ng_grep_add_host_type_info,
};
static const struct ng_parse_type ng_grep_add_path_type = {
	&ng_parse_fixedstring_type,
	&ng_grep_add_path_type_info,
};
static const struct ng_parse_type ng_grep_add_prot_type = {
	&ng_parse_fixedstring_type,
	&ng_grep_add_prot_type_info,
};

/* data structures for flush comand */

struct ng_grep_flush_out {
	u_char	rc;
};
#define NG_GREP_FLUSH_OUT_TYPE_INFO {				\
	{ "err",	&ng_parse_uint8_type		},	\
	{ NULL }						\
}


/* data structures for add_url comand */
/*
struct ng_grep_add_url_in {
	u_char	 url[255];
};

struct ng_grep_add_url_out {
	u_char	rc;
	u_char	flag_ic;
	u_char	flag_re;
	u_char	host[255];
	u_char	path[255];
};

#define NG_GREP_ADD_URL_IN_TYPE_INFO {				\
	{ "url",	&ng_parse_string_type		},	\
	{ NULL }						\
}

#define NG_GREP_ADD_URL_OUT_TYPE_INFO {				\
	{ "err",	&ng_parse_uint8_type		},	\
	{ "i_c",	&ng_parse_uint8_type		},	\
	{ "rex",	&ng_parse_uint8_type		},	\
	{ "host",	&ng_grep_add_url_host_type	},	\
	{ "path",	&ng_grep_add_url_path_type	},	\
	{ NULL }						\
}

static const struct ng_parse_fixedstring_info ng_grep_add_url_host_type_info = {
	255
};
static const struct ng_parse_fixedstring_info ng_grep_add_url_path_type_info = {
	255
};

static const struct ng_parse_type ng_grep_add_url_host_type = {
	&ng_parse_fixedstring_type,
	&ng_grep_add_url_host_type_info,
};
static const struct ng_parse_type ng_grep_add_url_path_type = {
	&ng_parse_fixedstring_type,
	&ng_grep_add_url_path_type_info,
};
*/
#endif /* _NETGRAPH_NG_GREP_H_ */
